unit anews1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, png;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
crlf=#13+#10;
header1='<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html>'+
'<head><meta HTTP-EQUIV="Content-Type" content="text/html;charset=cp866">'+
//'<title>AlCoNews</title>'+
'<style type="text/css">'+crlf+'body{background:black}'+crlf+
'pre{color:#00cccc;font-size:';
header2='px;font-weight:bold;line-height:';
header3='px}'+crlf+'.b{color:#0000cc}'+crlf+
'.r{color:#cc0000}'+crlf+'.m{color:#cc00cc}'+crlf+
'.g{color:#00cc00}'+crlf+'.c{color:#00cccc}'+crlf+'.y{color:#cccc00}'+crlf+
'.w{color:#cccccc}'+crlf+'</style></head><body><pre>'+crlf;
footer=crlf+'</pre></body></html>';
spans:array[1..8]of string=
('<span class=b>',
'<span class=r>',
'<span class=m>',
'<span class=g>',
'<span class=c>',
'<span class=y>',
'<span class=w>',
'');
unspan='</span>';
img='<img src="';
unimg='" width="640">'+crlf;

pal:array[0..15]of tcolor=
  (0,$a80000,$a8,$a800a8,$a800,$a8a800,$a8a8,$a8a8a8,
   $101010,$ff0000,$ff,$ff00ff,$ff00,$ffff00,$ffff,$ffffff);
var
  Form1: TForm1;
  fin,fout:file of char;
  pix:array[1..9999,1..2]of byte;
  bm,bm1:tbitmap;
  chr:array[0..31,0..8]of byte;
 fn,s:string;
 b,ink,pap,i,j,k,n,l,pic:integer;
 atr:byte;
 c,c1:char;
 clr,flag,hobeta:boolean;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenDialog1.InitialDir:=GetCurrentDir;
  SaveDialog1.InitialDir:=OpenDialog1.InitialDir;
//  Button1Click(Sender);
end;

procedure writer(s:string);
var i:integer;
begin
  for i:=1 to length(s)do write(fout,s[i]);
end;

procedure save(c:char);
begin
  case c of
   '<':writer('&lt;');
   '>':writer('&gt;');
  '~':writer('&tilde;'); //comment this line if you use Netscape 4.7
   #127:writer('&copy;');
   #0,#10:if clr then begin writer(unspan);clr:=false end;
   #13:begin
     if clr then begin writer(unspan);clr:=false end;
     writer(crlf);
    end;
   #1,#2,#3,#4,#5,#6,#7:
    begin
     if clr then writer(unspan);
     writer(' '+spans[ord(c)]);
     clr:=true;
    end;
   #8:begin
     if clr then writer(unspan);
     writer(' ');
     clr:=false;
    end;
   else write(fout,c);
  end;
end;

function load:char;
var c:char;
begin
  read(fin,c);
  load:=c;
end;

procedure palitra(var bm:tbitmap);
var
 hpal: HPALETTE;
 plt:PlogPalette;
 i:integer;
begin
 plt := nil;
 try
   GetMem(plt,sizeof(TLogPalette)+sizeof(TPaletteEntry)*15);
   plt.palVersion := $300;
   plt.palNumEntries := 16;
   for i:=0 to 15 do
    PColor(@plt.palPalEntry[i].peRed)^:=pal[i];
   hpal := CreatePalette(plt^);
   if hpal<>0 then bm.Palette := hpal;
 finally
   FreeMem(plt);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 i,n1,l1,k1:integer;
 rect1,rect2:trect;
 p:PByteArray;
 png:tPNG;
begin
  if not(OpenDialog1.Execute)then exit;
  fn:=OpenDialog1.FileName;
  i:=pos('.',fn);
  hobeta:=false;
  if i>0 then begin
   hobeta:=(fn[i+1]='$')and(length(fn)=i+2);
   Delete(fn,i,length(fn)-i+1);
  end;
  while pos('\',fn)>0 do
   Delete(fn,1,pos('\',fn));
  SaveDialog1.FileName:=fn;
  if not(SaveDialog1.Execute)then exit;
  AssignFile(fout,SaveDialog1.FileName);
  AssignFile(fin,OpenDialog1.FileName);
  rewrite(fout);
  reset(fin);
  if hobeta then seek(fin,17);
  writer(header1);
  if checkbox1.checked then writer('25')else writer('17');
  writer(header2);
  if checkbox1.checked then writer('25')else writer('17');
  writer(header3);

  for i:=1 to 9999 do
   pix[i,2]:=0;
  pic:=1;

  repeat
   s:='';
   clr:=false;
   repeat
    c:=load;
    s:=s+c;
   until(c=#13)or eof(fin)or(c=#0);
   if(length(s)>1)
   then begin
    c1:=s[length(s)-1];
    if ord(c1)in[1,2,3,4,5,6,7]
    then begin
     clr:=true;
     writer(spans[ord(c1)]);
     s[length(s)-1]:=#8;
    end;
   end;
   flag:=(s[1]=#255)and(s[2]>#127);
   if(pix[pic,1]<>ord(s[2])-128-pix[pic,2])or not flag
   then
    if pix[pic,2]>0
    then begin
     n:=pix[pic,1];
     l:=pix[pic,2];
     j:=pic;
     for i:=1 to pic-1 do
      if(pix[i,1]=n)and(pix[i,2]=l)
      then j:=i;
     if j=pic
     then inc(pic)
     else pix[pic,2]:=0;
     writer(img);
     if radiobutton1.checked
     then writer(inttostr(j)+fn+'.bmp')
     else writer(inttostr(j)+fn+'.png');
     writer(unimg);
    end;
   if flag
   then begin
    if(pix[pic,2]=0)
    then pix[pic,1]:=ord(s[2])-128;
    inc(pix[pic,2])
   end
   else for i:=1 to length(s)do save(s[i]);
  until eof(fin)or(c=#0);

  bm:=tbitmap.create;
  bm.Height:=128*8;
  bm.Width:=256;
  bm1:=tbitmap.create;
  bm1.Width:=256;
  if radiobutton1.checked
  then bm.PixelFormat:=pf4bit
  else bm.PixelFormat:=pf8bit;
  bm1.PixelFormat:=bm.PixelFormat;
  palitra(bm);
  palitra(bm1);
  png:=tPNG.Create;
  j:=0;
  i:=0;
  k:=0;
  while not eof(fin)do
  begin
    c:=load;
    chr[i,j]:=ord(c);
    inc(i);
    if i=32
    then begin
     i:=0;
     inc(j);
    end;
    if j=9 then begin
     j:=0;
     for n1:=0 to 31 do
     begin
      atr:=chr[n1,8];
      ink:=atr and 7+(atr and 64)shr 3;
      pap:=(atr and 120)shr 3;
      for k1:=0 to 7 do //rows
      begin
       p:=bm.scanline[k*8+k1];
       b:=chr[n1,k1];
      if bm.PixelFormat=pf8bit
      then
       for l1:=0 to 7 do //bits
       begin
        if(b and 128)=0
        then p[n1*8+l1]:=pap
        else p[n1*8+l1]:=ink;
        b:=b shl 1;
       end
      else
       for l1:=0 to 7 do //bits
       begin
        if(b and 128)=0
        then p[n1*4+l1 div 2]:=p[n1*4+l1 div 2]shl 4+pap
        else p[n1*4+l1 div 2]:=p[n1*4+l1 div 2]shl 4+ink;
        b:=b shl 1;
       end;
      end;
     end;
     inc(k);
    end;
  end;
  rect1.Left:=0;rect2.Left:=0;
  rect1.Right:=256;rect2.Right:=256;
  rect1.Top:=0;
  for i:=1 to pic-1 do
  begin
   bm1.Height:=pix[i,2]*8;
   rect1.Bottom:=pix[i,2]*8;
   rect2.Top:=pix[i,1]*8;
   rect2.Bottom:=rect2.Top+pix[i,2]*8;
   bm1.canvas.CopyRect(rect1,bm.canvas,rect2);
   if radiobutton1.checked
   then bm1.SaveToFile(inttostr(i)+fn+'.bmp')
   else begin
    png.Assign(bm1);
    png.SaveToFile(inttostr(i)+fn+'.png')
   end;
  end;
  writer(footer);
  CloseFile(fout);
  CloseFile(fin);
  bm.Free;
  bm1.Free;
  png.Free;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=27 then Close;
end;

end.
